function classify

clear global numimage newimage dmean dall

global faces num numrow numcol vecsize meanface newfaces V D eigfaces errors
global meanall n dirnum Sb Sw Wfld Wopt Sw2 Sb2 I imagestr meanstr fishstr
global rimage projmean projimage dall dmean newimage numimage projff Wqr
global projqr dall_qr dmean_qr projimage_qr projmean_qr
global Wmean projmf dall_mean dmean_mean projimage_mean projmean_mean
global Wsvd1 projsvd1 dall_svd1 dmean_svd1 projimage_svd1 projmean_svd1
global Wsvd2 projsvd2 dall_svd2 dmean_svd2 projimage_svd2 projmean_svd2

% get the directory from the user
dirstr = inputdlg('Please enter the directory containing the images');
[rows, cols] = size(dirstr);
if rows == 0 & cols == 0
    return;
end
files = dir(char(dirstr));
[rows, cols] = size(files);

% form the image matrice
h = waitbar(0, 'Please wait while loading the images ...');
numimage = 0;
for i = 1:rows
    if strcmp(files(i).name, '.') == 0 & strcmp(files(i).name, '..') == 0
        [r,c] = size(files(i).name);
        ext = files(i).name(c-3:c);
        if strcmp(files(i).name(c-3), '.') == 1 & (strcmp(ext, 'jpg') == 0 | strcmp(ext, 'bmp') == 0 | strcmp(ext, 'tif') == 0 | strcmp(ext, 'png') == 0 | strcmp(ext, 'hdf') == 0 | strcmp(ext, 'pcx') == 0 | strcmp(ext, 'xwd') == 0)

            face = imread([char(dirstr), '/', files(i).name]);
	    f = reshape(transpose(face), vecsize, 1);
	    f = double(f) - min(double(f));
	    newimage(:,numimage+1) = round(f * 255 / max(f));
            numimage = numimage + 1;
        end
    end
    waitbar(i/rows, h);
end
close(h);

% for fisherface
projff = Wopt' * newimage;
for i = 1:numimage
    for j = 1:n
        dall(j,i) = norm(projff(:,i) - projimage(:,j));
    end
    for j = 1:dirnum
        dmean(j,i) = norm(projff(:,i) - projmean(:,j));
    end
end

% for qr
projqr = Wqr' * newimage;
for i = 1:numimage
    for j = 1:n
        dall_qr(j,i) = norm(projqr(:,i) - projimage_qr(:,j));
    end
    for j = 1:dirnum
        dmean_qr(j,i) = norm(projqr(:,i) - projmean_qr(:,j));
    end
end

% for meanface
projmf = Wmean' * newimage;
for i = 1:numimage
    for j = 1:n
        dall_mean(j,i) = norm(projmf(:,i) - projimage_mean(:,j));
    end
    for j = 1:dirnum
        dmean_mean(j,i) = norm(projmf(:,i) - projmean_mean(:,j));
    end
end

% for svd1
projsvd1 = Wsvd1' * newimage;
for i = 1:numimage
    for j = 1:n
        dall_svd1(j,i) = norm(projsvd1(:,i) - projimage_svd1(:,j));
    end
    for j = 1:dirnum
        dmean_svd1(j,i) = norm(projsvd1(:,i) - projmean_svd1(:,j));
    end
end

% for svd2
projsvd2 = Wsvd2' * newimage;
for i = 1:numimage
    for j = 1:n
        dall_svd2(j,i) = norm(projsvd2(:,i) - projimage_svd2(:,j));
    end
    for j = 1:dirnum
        dmean_svd2(j,i) = norm(projsvd2(:,i) - projmean_svd2(:,j));
    end
end

set(findobj('Tag', 'classify_mb'), 'Enable', 'on');
set(findobj('Tag', 'classify_list'), 'Enable', 'on');
set(findobj('Tag', 'classify_list'), 'Value', 1);

str = cell(numimage, 1);
for i = 1:numimage
    str(i) = cellstr(['Test Image ', int2str(i)]);
end
set(findobj('Tag', 'classify_list'), 'String', str);

